<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Settings extends Controller_Handler {

        public function before() {
            parent::before();

            $this->user->checkAccess(User::RIGHTS_AUTHORIZED);
        }

        public function action_changeLogin() {
            $config = Kohana::$config->load('security.securityPolicy');
            $this->post->rule('login', $config['login']['allowedSymbols'])->rule('login', 'not_empty');
            $arr['success'] = true;

            if ($this->post->check()) {
                if (!Model_Account::changeLogin($this->user->ID, $this->post['login']))
                    $this->post->error('login', 'already_exists');
                else
                    $this->user->Login = $this->post['login'];
            }

            if ($this->post->errors()) {
                $arr['success'] = false;
                $arr['errors'] = $this->post->errors();
            }

            $this->response->body(json_encode($arr));
        }

        public function action_changePassword()
        {
            $config = Kohana::$config->load('security.securityPolicy');
            $this->post
                ->rule('password', 'min_length', array(':value', $config['password']['length']))
                ->rule('confirm_password', 'matches', array(':validation', 'confirm_password', 'password'));
            $arr['success'] = true;
            $old = $this->post['old_password'];
            $new = $this->post['password'];
            if(!$this->post->check())
            {
                $arr['success'] = false;
                $arr['errors'] = $this->post->errors();
                $this->response->body(json_encode($arr));
                return;
            }
            if(!User::instance()->changePassword($old, $new))
            {
                $arr['success'] = false;
                $this->post->error('login', 'invalid_password');
                $arr['errors'] = $this->post->errors();
                $this->response->body(json_encode($arr));
                return;
            }
            $this->response->body(json_encode($arr));
        }

        public function action_editProfile()
        {
            $this->user->checkAccess(User::RIGHTS_TEACHER);

            $this->post
                    ->rule('firstName', 'not_empty')
                    // ->rule('firstName', 'alpha_dash', array(':value', TRUE))
                    // ->rule('secondName', 'not_empty')
                    // ->rule('secondName', 'alpha_dash', array(':value', TRUE))
                    ->rule('lastName', 'not_empty')
                    // ->rule('lastName', 'alpha_dash', array(':value', TRUE))
                    ->rule('jobPositionID', 'not_empty')
                    ->rule('jobPositionID', 'digit')
                    ->rule('departmentID', 'not_empty')
                    ->rule('departmentID', 'digit');
            if($this->post->check())
            {
                User::instance()->changeProfile($this->post->data());
            }
        }

        # todo: duplicate at handler/AdmTeachers
        public function action_getDepartmentsList()
        {
            $faculty = Model_Faculty::with($this->post['facultyID']);
            $departments = $faculty->getDepartments();
            $this->response->body(json_encode($departments));
        }

        public function action_setSemesterID() {
            $semester = $this->post['semesterID'];
            if (is_int($semester) && $semester > 0) {
                $this->user->SemesterID = $semester;
            }
        }
}
